Botan 2.19.5 Crypto and TLS for C&

Public Member Functions | Protected Attributes | List of all members
Botan::ElGamal_PrivateKey Class Referencefinal

`#include <elgamal.h>`

Inheritance diagram for Botan::ElGamal_PrivateKey:

## Public Member Functions
std::string | algo_name () const override
AlgorithmIdentifier | algorithm_identifier () const override
bool | check_key (RandomNumberGenerator &rng, bool) const override
std::unique_ptr< PK_Ops::Decryption > | create_decryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const override
std::unique_ptr< PK_Ops::Encryption > | create_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const override
virtual std::unique_ptr< PK_Ops::KEM_Decryption > | create_kem_decryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
virtual std::unique_ptr< PK_Ops::KEM_Encryption > | create_kem_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
virtual std::unique_ptr< PK_Ops::Key_Agreement > | create_key_agreement_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
virtual std::unique_ptr< PK_Ops::Signature > | create_signature_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
virtual std::unique_ptr< PK_Ops::Verification > | create_verification_op (const std::string &params, const std::string &provider) const
virtual Signature_Format | default_x509_signature_format () const
| ElGamal_PrivateKey (const AlgorithmIdentifier &alg_id, const secure_vector< uint8_t > &key_bits)
| ElGamal_PrivateKey (RandomNumberGenerator &rng, const DL_Group &group, const BigInt &priv_key=0)
size_t | estimated_strength () const override
std::string | fingerprint (const std::string &alg) const
std::string | fingerprint_private (const std::string &alg) const
std::string | fingerprint_public (const std::string &alg="SHA-256") const
const DL_Group & | get_domain () const
const DL_Group & | get_group () const
virtual OID | get_oid () const
const BigInt & | get_x () const
const BigInt & | get_y () const
DL_Group::Format | group_format () const override
const BigInt & | group_g () const
const BigInt & | group_p () const
const BigInt & | group_q () const
size_t | key_length () const override
virtual size_t | message_part_size () const
virtual size_t | message_parts () const
virtual AlgorithmIdentifier | pkcs8_algorithm_identifier () const
secure_vector< uint8_t > | private_key_bits () const override
secure_vector< uint8_t > | private_key_info () const
std::vector< uint8_t > | public_key_bits () const override
virtual bool | stateful_operation () const
std::vector< uint8_t > | subject_public_key () const

## Protected Attributes
DL_Group | m_group
BigInt | m_x
BigInt | m_y

## Detailed Description

ElGamal Private Key

Definition at line 53 of file elgamal.h.

## Constructor & Destructor Documentation

## ◆ ElGamal_PrivateKey() [1/2]

Botan::ElGamal_PrivateKey::ElGamal_PrivateKey | ( | const AlgorithmIdentifier & | alg_id,
|  | const secure_vector< uint8_t > & | key_bits
| ) |  |

Load a private key.

Parameters

  alg_id | the X.509 algorithm identifier
  key_bits | DER encoded key bits in ANSI X9.42 format

Definition at line 46 of file elgamal.cpp.

47 :
48 DL_Scheme_PrivateKey(alg_id, key_bits, DL_Group::ANSI_X9_42)
49 {
50 m_y = m_group.power_g_p(m_x, m_group.p_bits());
51 }
Botan::DL_Group::power_g_p
BigInt power_g_p(const BigInt &x) const
Definition: dl_group.cpp:535
Botan::DL_Group::p_bits
size_t p_bits() const
Definition: dl_group.cpp:451
Botan::DL_Group::ANSI_X9_42
@ ANSI_X9_42
Definition: dl_group.h:41
Botan::DL_Scheme_PrivateKey::m_x
BigInt m_x
Definition: dl_algo.h:135
Botan::DL_Scheme_PrivateKey::DL_Scheme_PrivateKey
DL_Scheme_PrivateKey()=default
Botan::DL_Scheme_PublicKey::m_y
BigInt m_y
Definition: dl_algo.h:92
Botan::DL_Scheme_PublicKey::m_group
DL_Group m_group
Definition: dl_algo.h:97

References Botan::DL_Scheme_PublicKey::m_group, Botan::DL_Scheme_PrivateKey::m_x, Botan::DL_Scheme_PublicKey::m_y, Botan::DL_Group::p_bits(), and Botan::DL_Group::power_g_p().

## ◆ ElGamal_PrivateKey() [2/2]

Botan::ElGamal_PrivateKey::ElGamal_PrivateKey | ( | RandomNumberGenerator & | rng,
|  | const DL_Group & | group,
|  | const BigInt & | priv_key = `0`
| ) |  |

Create a private key.

Parameters

  rng | random number generator to use
  group | the group to be used in the key
  priv_key | the key's secret value (or if zero, generate a new key)

Definition at line 27 of file elgamal.cpp.

30 {
31 m_x = x;
32 m_group = group;
33
34 if(m_x.is_zero())
35 {
36 const size_t exp_bits = m_group.exponent_bits();
37 m_x.randomize(rng, exp_bits);
38 m_y = m_group.power_g_p(m_x, exp_bits);
39 }
40 else
41 {
42 m_y = m_group.power_g_p(m_x, m_group.p_bits());
43 }
44 }
Botan::BigInt::randomize
void randomize(RandomNumberGenerator &rng, size_t bitsize, bool set_high_bit=true)
Definition: big_rand.cpp:17
Botan::BigInt::is_zero
bool is_zero() const
Definition: bigint.h:427
Botan::DL_Group::exponent_bits
size_t exponent_bits() const
Definition: dl_group.cpp:478

References Botan::DL_Group::exponent_bits(), Botan::BigInt::is_zero(), Botan::DL_Scheme_PublicKey::m_group, Botan::DL_Scheme_PrivateKey::m_x, Botan::DL_Scheme_PublicKey::m_y, Botan::DL_Group::p_bits(), Botan::DL_Group::power_g_p(), and Botan::BigInt::randomize().

## Member Function Documentation

## ◆ algo_name()

std::string Botan::ElGamal_PublicKey::algo_name | ( |  | ) | const
| inline override virtual inherited

Get the name of the underlying public key scheme.

Returns
  name of the public key scheme

Implements Botan::Public_Key.

Definition at line 21 of file elgamal.h.

21{ return "ElGamal"; }

Referenced by create_decryption_op(), and Botan::ElGamal_PublicKey::create_encryption_op().

## ◆ algorithm_identifier()

AlgorithmIdentifier Botan::DL_Scheme_PublicKey::algorithm_identifier | ( |  | ) | const
| override virtual inherited

Returns
  X.509 AlgorithmIdentifier for this key

Implements Botan::Public_Key.

Definition at line 25 of file dl_algo.cpp.

26 {
27 return AlgorithmIdentifier(get_oid(),
28 m_group.DER_encode(group_format()));
29 }
Botan::DL_Group::DER_encode
std::vector< uint8_t > DER_encode(Format format) const
Definition: dl_group.cpp:553
Botan::DL_Scheme_PublicKey::group_format
virtual DL_Group::Format group_format() const =0
Botan::Public_Key::get_oid
virtual OID get_oid() const
Definition: pk_keys.cpp:53

References Botan::DL_Group::DER_encode(), Botan::Public_Key::get_oid(), Botan::DL_Scheme_PublicKey::group_format(), and Botan::DL_Scheme_PublicKey::m_group.

## ◆ check_key()

bool Botan::ElGamal_PrivateKey::check_key | ( | RandomNumberGenerator & | rng,
|  | bool | strong
| ) |  | const
| override virtual

Test the key values for consistency.

Parameters

  rng | rng to use
  strong | whether to perform strong and lengthy version of the test

Returns
  true if the test is passed

Reimplemented from Botan::DL_Scheme_PrivateKey.

Definition at line 56 of file elgamal.cpp.

58 {
59 if(!DL_Scheme_PrivateKey::check_key(rng, strong))
60 return false;
61
62 if(!strong)
63 return true;
64
65 return KeyPair::encryption_consistency_check(rng, *this, "OAEP(SHA-256)");
66 }
Botan::DL_Scheme_PrivateKey::check_key
bool check_key(RandomNumberGenerator &rng, bool) const override
Definition: dl_algo.cpp:78
Botan::KeyPair::encryption_consistency_check
bool encryption_consistency_check(RandomNumberGenerator &rng, const Private_Key &private_key, const Public_Key &public_key, const std::string &padding)
Definition: keypair.cpp:19

References Botan::DL_Scheme_PrivateKey::check_key(), and Botan::KeyPair::encryption_consistency_check().

## ◆ create_decryption_op()

std::unique_ptr< PK_Ops::Decryption > Botan::ElGamal_PrivateKey::create_decryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| override virtual

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return an decryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented from Botan::Private_Key.

Definition at line 204 of file elgamal.cpp.

207 {
208 if(provider == "base" || provider.empty())
209 return std::unique_ptr<PK_Ops::Decryption>(new ElGamal_Decryption_Operation(*this, params, rng));
210 throw Provider_Not_Found(algo_name(), provider);
211 }
Botan::ElGamal_PublicKey::algo_name
std::string algo_name() const override
Definition: elgamal.h:21

References Botan::ElGamal_PublicKey::algo_name().

## ◆ create_encryption_op()

std::unique_ptr< PK_Ops::Encryption > Botan::ElGamal_PublicKey::create_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| override virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return an encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented from Botan::Public_Key.

Definition at line 194 of file elgamal.cpp.

197 {
198 if(provider == "base" || provider.empty())
199 return std::unique_ptr<PK_Ops::Encryption>(new ElGamal_Encryption_Operation(*this, params));
200 throw Provider_Not_Found(algo_name(), provider);
201 }

References Botan::ElGamal_PublicKey::algo_name().

## ◆ create_kem_decryption_op()

std::unique_ptr< PK_Ops::KEM_Decryption > Botan::Private_Key::create_kem_decryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a KEM decryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::McEliece_PrivateKey, and Botan::RSA_PrivateKey.

Definition at line 122 of file pk_keys.cpp.

125 {
126 throw Lookup_Error(algo_name() + " does not support KEM decryption");
127 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_KEM_Decryptor::PK_KEM_Decryptor().

## ◆ create_kem_encryption_op()

std::unique_ptr< PK_Ops::KEM_Encryption > Botan::Public_Key::create_kem_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a KEM encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::McEliece_PublicKey, and Botan::RSA_PublicKey.

Definition at line 99 of file pk_keys.cpp.

102 {
103 throw Lookup_Error(algo_name() + " does not support KEM encryption");
104 }

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_KEM_Encryptor::PK_KEM_Encryptor().

## ◆ create_key_agreement_op()

std::unique_ptr< PK_Ops::Key_Agreement > Botan::Private_Key::create_key_agreement_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a key agreement operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::Curve25519_PrivateKey, Botan::DH_PrivateKey, and Botan::ECDH_PrivateKey.

Definition at line 138 of file pk_keys.cpp.

141 {
142 throw Lookup_Error(algo_name() + " does not support key agreement");
143 }

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_Key_Agreement::PK_Key_Agreement().

## ◆ create_signature_op()

std::unique_ptr< PK_Ops::Signature > Botan::Private_Key::create_signature_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a signature operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::XMSS_PrivateKey, Botan::TPM_PrivateKey, Botan::DSA_PrivateKey, Botan::ECDSA_PrivateKey, Botan::ECGDSA_PrivateKey, Botan::ECKCDSA_PrivateKey, Botan::Ed25519_PrivateKey, Botan::GOST_3410_PrivateKey, Botan::RSA_PrivateKey, and Botan::SM2_PrivateKey.

Definition at line 130 of file pk_keys.cpp.

133 {
134 throw Lookup_Error(algo_name() + " does not support signatures");
135 }

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_Signer::PK_Signer().

## ◆ create_verification_op()

std::unique_ptr< PK_Ops::Verification > Botan::Public_Key::create_verification_op | ( | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a verification operation for this key/params or throw

Parameters

  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::XMSS_PublicKey, Botan::DSA_PublicKey, Botan::ECDSA_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, Botan::Ed25519_PublicKey, Botan::GOST_3410_PublicKey, Botan::RSA_PublicKey, Botan::SM2_PublicKey, and Botan::XMSS_WOTS_Addressed_PublicKey.

Definition at line 107 of file pk_keys.cpp.

109 {
110 throw Lookup_Error(algo_name() + " does not support verification");
111 }

References Botan::Public_Key::algo_name().

Referenced by Botan::XMSS_WOTS_Addressed_PublicKey::create_verification_op(), and Botan::PK_Verifier::PK_Verifier().

## ◆ default_x509_signature_format()

virtual Signature_Format Botan::Public_Key::default_x509_signature_format | ( |  | ) | const
| inline virtual inherited

Reimplemented in Botan::GOST_3410_PublicKey.

Definition at line 125 of file pk_keys.h.

126 {
127 return (this->message_parts() >= 2) ? DER_SEQUENCE : IEEE_1363;
128 }
Botan::Public_Key::message_parts
virtual size_t message_parts() const
Definition: pk_keys.h:112
Botan::DER_SEQUENCE
@ DER_SEQUENCE
Definition: pk_keys.h:23
Botan::IEEE_1363
@ IEEE_1363
Definition: pk_keys.h:23

References Botan::DER_SEQUENCE, and Botan::IEEE_1363.

Referenced by Botan::X509_Object::choose_sig_format(), and Botan::X509_Object::verify_signature().

## ◆ estimated_strength()

size_t Botan::DL_Scheme_PublicKey::estimated_strength | ( |  | ) | const
| override virtual inherited

Return the estimated strength of the underlying key against the best currently known attack. Note that this ignores anything but pure attacks against the key itself and do not take into account padding schemes, usage mistakes, etc which might reduce the strength. However it does suffice to provide an upper bound.

Returns
  estimated strength in bits

Implements Botan::Public_Key.

Definition at line 20 of file dl_algo.cpp.

21 {
22 return m_group.estimated_strength();
23 }
Botan::DL_Group::estimated_strength
size_t estimated_strength() const
Definition: dl_group.cpp:473

References Botan::DL_Group::estimated_strength(), and Botan::DL_Scheme_PublicKey::m_group.

## ◆ fingerprint()

std::string Botan::Private_Key::fingerprint | ( | const std::string & | alg | ) | const
| inline inherited

Definition at line 215 of file pk_keys.h.

216 {
217 return fingerprint_private(alg); // match behavior in previous versions
218 }
Botan::Private_Key::fingerprint_private
std::string fingerprint_private(const std::string &alg) const
Definition: pk_keys.cpp:85

## ◆ fingerprint_private()

std::string Botan::Private_Key::fingerprint_private | ( | const std::string & | alg | ) | const
| inherited

Returns
  Hash of the PKCS #8 encoding for this key object

Definition at line 85 of file pk_keys.cpp.

86 {
87 return create_hex_fingerprint(private_key_bits(), hash_algo);
88 }
Botan::Private_Key::private_key_bits
virtual secure_vector< uint8_t > private_key_bits() const =0
Botan::create_hex_fingerprint
std::string create_hex_fingerprint(const uint8_t bits[], size_t bits_len, const std::string &hash_name)
Definition: pk_keys.cpp:17
hash_algo
AlgorithmIdentifier hash_algo
Definition: x509_obj.cpp:22

References Botan::create_hex_fingerprint(), hash_algo, and Botan::Private_Key::private_key_bits().

Referenced by Botan::Certificate_Store_In_SQL::find_certs_for_key(), Botan::Certificate_Store_In_SQL::insert_key(), and Botan::Certificate_Store_In_SQL::remove_key().

## ◆ fingerprint_public()

std::string Botan::Public_Key::fingerprint_public | ( | const std::string & | alg = `"SHA-256"` | ) | const
| inherited

Returns
  Hash of the subject public key

Definition at line 77 of file pk_keys.cpp.

78 {
79 return create_hex_fingerprint(subject_public_key(), hash_algo);
80 }
Botan::Public_Key::subject_public_key
std::vector< uint8_t > subject_public_key() const
Definition: pk_keys.cpp:38

References Botan::create_hex_fingerprint(), hash_algo, and Botan::Public_Key::subject_public_key().

## ◆ get_domain()

const DL_Group & Botan::DL_Scheme_PublicKey::get_domain | ( |  | ) | const
| inline inherited

Get the DL domain parameters of this key.

Returns
  DL domain parameters of this key

Definition at line 32 of file dl_algo.h.

32{ return m_group; }

## ◆ get_group()

const DL_Group & Botan::DL_Scheme_PublicKey::get_group | ( |  | ) | const
| inline inherited

Get the DL domain parameters of this key.

Returns
  DL domain parameters of this key

Definition at line 38 of file dl_algo.h.

38{ return m_group; }

## ◆ get_oid()

OID Botan::Public_Key::get_oid | ( |  | ) | const
| virtual inherited

Get the OID of the underlying public key scheme.

Returns
  OID of the public key scheme

Reimplemented in Botan::XMSS_WOTS_Addressed_PublicKey.

Definition at line 53 of file pk_keys.cpp.

54 {
55 const OID o = OIDS::str2oid_or_empty(algo_name());
56 if(o.empty())
57 throw Lookup_Error("PK algo " + algo_name() + " has no defined OIDs");
58 return o;
59 }
Botan::OIDS::str2oid_or_empty
BOTAN_UNSTABLE_API OID str2oid_or_empty(const std::string &name)
Definition: oids.cpp:116

References Botan::Public_Key::algo_name(), Botan::OID::empty(), and Botan::OIDS::str2oid_or_empty().

Referenced by Botan::TPM_PrivateKey::algorithm_identifier(), Botan::Curve25519_PublicKey::algorithm_identifier(), Botan::DL_Scheme_PublicKey::algorithm_identifier(), Botan::EC_PublicKey::algorithm_identifier(), Botan::Ed25519_PublicKey::algorithm_identifier(), Botan::GOST_3410_PublicKey::algorithm_identifier(), Botan::McEliece_PublicKey::algorithm_identifier(), Botan::RSA_PublicKey::algorithm_identifier(), and Botan::XMSS_WOTS_Addressed_PublicKey::get_oid().

## ◆ get_x()

const BigInt & Botan::DL_Scheme_PrivateKey::get_x | ( |  | ) | const
| inline inherited

Get the secret key x.

Returns
  secret key

Definition at line 113 of file dl_algo.h.

113{ return m_x; }

## ◆ get_y()

const BigInt & Botan::DL_Scheme_PublicKey::get_y | ( |  | ) | const
| inline inherited

Get the public value y with y = g^x mod p where x is the secret key.

Definition at line 43 of file dl_algo.h.

43{ return m_y; }

## ◆ group_format()

DL_Group::Format Botan::ElGamal_PublicKey::group_format | ( |  | ) | const
| inline override virtual inherited

Get the underlying groups encoding format.

Returns
  encoding format

Implements Botan::DL_Scheme_PublicKey.

Definition at line 22 of file elgamal.h.

22{ return DL_Group::ANSI_X9_42; }

References Botan::DL_Group::ANSI_X9_42.

## ◆ group_g()

const BigInt & Botan::DL_Scheme_PublicKey::group_g | ( |  | ) | const
| inline inherited

Get the generator g of the underlying DL group.

Returns
  generator g

Definition at line 61 of file dl_algo.h.

61{ return m_group.get_g(); }
Botan::DL_Group::get_g
const BigInt & get_g() const
Definition: dl_group.cpp:433

## ◆ group_p()

const BigInt & Botan::DL_Scheme_PublicKey::group_p | ( |  | ) | const
| inline inherited

Get the prime p of the underlying DL group.

Returns
  prime p

Definition at line 49 of file dl_algo.h.

49{ return m_group.get_p(); }
Botan::DL_Group::get_p
const BigInt & get_p() const
Definition: dl_group.cpp:425

Referenced by Botan::DH_PublicKey::public_value().

## ◆ group_q()

const BigInt & Botan::DL_Scheme_PublicKey::group_q | ( |  | ) | const
| inline inherited

Get the prime q of the underlying DL group.

Returns
  prime q

Definition at line 55 of file dl_algo.h.

55{ return m_group.get_q(); }
Botan::DL_Group::get_q
const BigInt & get_q() const
Definition: dl_group.cpp:441

Referenced by Botan::DSA_PrivateKey::check_key(), and Botan::DSA_PrivateKey::DSA_PrivateKey().

## ◆ key_length()

size_t Botan::DL_Scheme_PublicKey::key_length | ( |  | ) | const
| override virtual inherited

Return an integer value best approximating the length of the primary security parameter. For example for RSA this will be the size of the modulus, for ECDSA the size of the ECC group, and for McEliece the size of the code will be returned.

Implements Botan::Public_Key.

Definition at line 15 of file dl_algo.cpp.

16 {
17 return m_group.p_bits();
18 }

References Botan::DL_Scheme_PublicKey::m_group, and Botan::DL_Group::p_bits().

## ◆ message_part_size()

virtual size_t Botan::Public_Key::message_part_size | ( |  | ) | const
| inline virtual inherited

Returns how large each of the message parts refered to by message_parts() is

This function is public but applications should have few reasons to ever call this.

Returns
  size of the message parts in bits

Reimplemented in Botan::DSA_PublicKey, Botan::ECDSA_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, Botan::GOST_3410_PublicKey, and Botan::SM2_PublicKey.

Definition at line 123 of file pk_keys.h.

123{ return 0; }

Referenced by Botan::PK_Signer::PK_Signer(), and Botan::PK_Verifier::PK_Verifier().

## ◆ message_parts()

virtual size_t Botan::Public_Key::message_parts | ( |  | ) | const
| inline virtual inherited

Returns more than 1 if the output of this algorithm (ciphertext, signature) should be treated as more than one value. This is used for algorithms like DSA and ECDSA, where the (r,s) output pair can be encoded as either a plain binary list or a TLV tagged DER encoding depending on the protocol.

This function is public but applications should have few reasons to ever call this.

Returns
  number of message parts

Reimplemented in Botan::DSA_PublicKey, Botan::ECDSA_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, Botan::GOST_3410_PublicKey, and Botan::SM2_PublicKey.

Definition at line 112 of file pk_keys.h.

112{ return 1; }

Referenced by Botan::PK_Signer::PK_Signer(), and Botan::PK_Verifier::PK_Verifier().

## ◆ pkcs8_algorithm_identifier()

virtual AlgorithmIdentifier Botan::Private_Key::pkcs8_algorithm_identifier | ( |  | ) | const
| inline virtual inherited

Returns
  PKCS #8 AlgorithmIdentifier for this key Might be different from the X.509 identifier, but normally is not

Reimplemented in Botan::GOST_3410_PrivateKey, Botan::XMSS_WOTS_PrivateKey, and Botan::XMSS_WOTS_Addressed_PrivateKey.

Definition at line 204 of file pk_keys.h.

205 { return algorithm_identifier(); }
Botan::Public_Key::algorithm_identifier
virtual AlgorithmIdentifier algorithm_identifier() const =0

Referenced by Botan::Private_Key::private_key_info().

## ◆ private_key_bits()

secure_vector< uint8_t > Botan::DL_Scheme_PrivateKey::private_key_bits | ( |  | ) | const
| override virtual inherited

Returns
  BER encoded private key bits

Implements Botan::Private_Key.

Definition at line 52 of file dl_algo.cpp.

53 {
54 return DER_Encoder().encode(m_x).get_contents();
55 }

References Botan::DER_Encoder::encode(), Botan::DER_Encoder::get_contents(), and Botan::DL_Scheme_PrivateKey::m_x.

## ◆ private_key_info()

secure_vector< uint8_t > Botan::Private_Key::private_key_info | ( |  | ) | const
| inherited

Returns
  PKCS #8 private key encoding for this key object

Definition at line 61 of file pk_keys.cpp.

62 {
63 const size_t PKCS8_VERSION = 0;
64
65 return DER_Encoder()
66 .start_cons(SEQUENCE)
67 .encode(PKCS8_VERSION)
68 .encode(pkcs8_algorithm_identifier())
69 .encode(private_key_bits(), OCTET_STRING)
70 .end_cons()
71 .get_contents();
72 }
Botan::Private_Key::pkcs8_algorithm_identifier
virtual AlgorithmIdentifier pkcs8_algorithm_identifier() const
Definition: pk_keys.h:204
Botan::SEQUENCE
@ SEQUENCE
Definition: asn1_obj.h:42
Botan::OCTET_STRING
@ OCTET_STRING
Definition: asn1_obj.h:38

References Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), Botan::DER_Encoder::get_contents(), Botan::OCTET_STRING, Botan::Private_Key::pkcs8_algorithm_identifier(), Botan::Private_Key::private_key_bits(), Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

Referenced by Botan::PKCS8::BER_encode(), Botan::PKCS8::BER_encode_encrypted_pbkdf_iter(), and Botan::PKCS8::BER_encode_encrypted_pbkdf_msec().

## ◆ public_key_bits()

std::vector< uint8_t > Botan::DL_Scheme_PublicKey::public_key_bits | ( |  | ) | const
| override virtual inherited

Returns
  BER encoded public key bits

Implements Botan::Public_Key.

Definition at line 31 of file dl_algo.cpp.

32 {
33 std::vector<uint8_t> output;
34 DER_Encoder(output).encode(m_y);
35 return output;
36 }

References Botan::DER_Encoder::encode(), and Botan::DL_Scheme_PublicKey::m_y.

## ◆ stateful_operation()

virtual bool Botan::Private_Key::stateful_operation | ( |  | ) | const
| inline virtual inherited

Reimplemented in Botan::XMSS_PrivateKey.

Definition at line 188 of file pk_keys.h.

188{ return false; }

## ◆ subject_public_key()

std::vector< uint8_t > Botan::Public_Key::subject_public_key | ( |  | ) | const
| inherited

Returns
  X.509 subject key encoding for this key object

Definition at line 38 of file pk_keys.cpp.

39 {
40 std::vector<uint8_t> output;
41
42 DER_Encoder(output).start_cons(SEQUENCE)
43 .encode(algorithm_identifier())
44 .encode(public_key_bits(), BIT_STRING)
45 .end_cons();
46
47 return output;
48 }
Botan::Public_Key::public_key_bits
virtual std::vector< uint8_t > public_key_bits() const =0
Botan::BIT_STRING
@ BIT_STRING
Definition: asn1_obj.h:37

References Botan::Public_Key::algorithm_identifier(), Botan::BIT_STRING, Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), Botan::Public_Key::public_key_bits(), Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

Referenced by Botan::X509::BER_encode(), Botan::PKCS10_Request::create(), Botan::Public_Key::fingerprint_public(), and Botan::X509::PEM_encode().

## Member Data Documentation

## ◆ m_group

DL_Group Botan::DL_Scheme_PublicKey::m_group
| protected inherited

The DL group

Definition at line 97 of file dl_algo.h.

Referenced by Botan::DL_Scheme_PublicKey::algorithm_identifier(), Botan::DL_Scheme_PublicKey::check_key(), Botan::DL_Scheme_PrivateKey::check_key(), Botan::DH_PrivateKey::DH_PrivateKey(), Botan::DH_PublicKey::DH_PublicKey(), Botan::DL_Scheme_PrivateKey::DL_Scheme_PrivateKey(), Botan::DSA_PrivateKey::DSA_PrivateKey(), Botan::DSA_PublicKey::DSA_PublicKey(), ElGamal_PrivateKey(), Botan::DL_Scheme_PublicKey::estimated_strength(), and Botan::DL_Scheme_PublicKey::key_length().

## ◆ m_x

BigInt Botan::DL_Scheme_PrivateKey::m_x
| protected inherited

The DL private key

Definition at line 135 of file dl_algo.h.

Referenced by Botan::DSA_PrivateKey::check_key(), Botan::DL_Scheme_PrivateKey::check_key(), Botan::DH_PrivateKey::DH_PrivateKey(), Botan::DL_Scheme_PrivateKey::DL_Scheme_PrivateKey(), Botan::DSA_PrivateKey::DSA_PrivateKey(), ElGamal_PrivateKey(), and Botan::DL_Scheme_PrivateKey::private_key_bits().

## ◆ m_y

BigInt Botan::DL_Scheme_PublicKey::m_y
| protected inherited

The DL public key

Definition at line 92 of file dl_algo.h.

Referenced by Botan::DL_Scheme_PublicKey::check_key(), Botan::DL_Scheme_PrivateKey::check_key(), Botan::DH_PrivateKey::DH_PrivateKey(), Botan::DH_PublicKey::DH_PublicKey(), Botan::DSA_PrivateKey::DSA_PrivateKey(), Botan::DSA_PublicKey::DSA_PublicKey(), ElGamal_PrivateKey(), Botan::DL_Scheme_PublicKey::public_key_bits(), and Botan::DH_PublicKey::public_value().

The documentation for this class was generated from the following files:

- src/lib/pubkey/elgamal/elgamal.h
- src/lib/pubkey/elgamal/elgamal.cpp